﻿var Interval;
var SerialNumber;
var ModuleName;
//var Units;
var TimeZone;

var L_UNITS_1_TEXT = "English";
var L_UNITS_2_TEXT = "Metric";

var unitsArray;

var L_TZ_1_TEXT	= "Atlantic";
var L_TZ_2_TEXT	= "Eastern";
var L_TZ_3_TEXT	= "Central";
var L_TZ_4_TEXT	= "Mountain";
var L_TZ_5_TEXT	= "Pacific";

var tzArray;
loadTZones();
loadUnits();

   // Initialize the gadget.
function init()
{
	var oBackground = document.getElementById("imgBackground");
	oBackground.src = "images/AtecBG.png)";
	oBackground.addShadow("black", 1, 90, 0 ,0)
	
//	System.Gadget.Settings.write("settingsSerial",3109665); // for debugging

	SerialNumber = System.Gadget.Settings.read("settingsSerial");
	ModuleName = System.Gadget.Settings.read("settingsName");	
	document.getElementById('serial').innerHTML = System.Gadget.Settings.read("settingsSerial");
	document.getElementById('name').innerHTML = System.Gadget.Settings.read("settingsName");
	getSensorData();
}

function loadTZones()
{
	tzArray = new Array();
	
	var tzIndex = 1;
  while(eval("typeof L_TZ_" + tzIndex + "_TEXT != 'undefined'"))
  {
      var tzName = eval("L_TZ_" + tzIndex + "_TEXT");
      
      if (tzName != "" && tzName != "NA")
      {
          tzArray.push(eval("L_TZ_" + tzIndex + "_TEXT"));
      }
      tzIndex++;
  }	

}

function loadUnits()
{
	unitsArray = new Array();
	unitsArray.push(eval("L_UNITS_1_TEXT"));
	unitsArray.push(eval("L_UNITS_2_TEXT"));	
}

function getSensorData()
{
	if (window.XMLHttpRequest)
	{// code for IE7+, Firefox, Chrome, Opera, Safari
 		xmlhttp=new XMLHttpRequest();
	}
	else
 	{// code for IE6, IE5
		xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
 	} 
 		
 	var url = "http://at.automationtec.net/ATWinGadget.php?serial=";
 	url += System.Gadget.Settings.read("settingsSerial");
 	url += "&tzone=" + (8-System.Gadget.Settings.read("settingsTZone"));
 	url += "&tunits=" + System.Gadget.Settings.read("settingsUnits");
  url += "&sid="+ Math.random(); // Prevents caching.

  xmlhttp.open("GET",url,true);

	xmlhttp.onreadystatechange=stateChangedSensor;
	xmlhttp.send(null);
	var t = setTimeout("getSensorData()",180000);   // 	 3 minute Update
}

function stateChangedSensor()
{
	if (xmlhttp.readyState == 4)
	{
		var AT200Data;
		
		AT200Data = xmlhttp.responseText;

		SplitAT200Data = AT200Data.split(",");
		
		
		document.getElementById('sensor').innerHTML = SplitAT200Data[0];
		document.getElementById('type').innerHTML = SplitAT200Data[1];
		document.getElementById('status').innerHTML = SplitAT200Data[2];
		document.getElementById('time').innerHTML = SplitAT200Data[3];		
	}
}

function SettingsClosed()
{
	Interval = System.Gadget.Settings.read("settingsUpdate");


	document.getElementById('serial').innerHTML = System.Gadget.Settings.read("settingsSerial");
	document.getElementById('name').innerHTML = System.Gadget.Settings.read("settingsName");

	getSensorData();
}

System.Gadget.onSettingsClosing = function SettingsClosing(event)
{
	if(event.closeAction == event.Action.commit)
	{

		System.Gadget.Settings.write("settingsSerial",SerialInput.value);
		System.Gadget.Settings.write("settingsName",txtName.value);
		System.Gadget.Settings.write("settingsUnits",Units.value);
		System.Gadget.Settings.write("settingsTZone",TZone.value);

	}
	event.cancel=false;
}
function settingsinit()
{
	SerialNumber = System.Gadget.Settings.read("settingsSerial");
	ModuleName = System.Gadget.Settings.read("settingsName");	

	if(SerialNumber)
		document.getElementById('SerialInput').value = SerialNumber;

	if(ModuleName)
		document.getElementById('txtName').value = ModuleName;

	selectTimeZone();
	selectUnits();
}

function selectTimeZone()
{
	
  	settingsTZ = System.Gadget.Settings.readString("settingsTZone");
    for (var i = 0; i < tzArray.length; i++)
    {
        var selectedState = false;
  
        if (i == settingsTZ)
        {
            selectedState = true;
        }

        TZone.options[i] = new Option(tzArray[i], i, false, selectedState);
    }	
}

function selectUnits()
{
	  settingsUnits = System.Gadget.Settings.readString("settingsUnits");
    for (var i = 0; i < unitsArray.length; i++)
    {
        var selectedState = false;
  
        if (i == settingsUnits)
        {
            selectedState = true;
        }

        Units.options[i] = new Option(unitsArray[i], i, false, selectedState);
    }	
}
